<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__utils_8h" kind="file" language="C++">
    <compoundname>cy_utils.h</compoundname>
      <sectiondef kind="define">
      <memberdef id="group__group__utils_1ga0a73602e14d41b2d525a1185597c8445" kind="define" prot="public" static="no">
        <name>CY_UNUSED_PARAMETER</name>
        <param><defname>x</defname></param>
        <initializer>( (void)(x) )</initializer>
        <briefdescription>
<para>Simple macro to supress the unused parameter warning by casting to void. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="40" column="9" file="output/libs/core-lib/include/cy_utils.h" line="40" />
      </memberdef>
      <memberdef id="group__group__utils_1gab333fce69ffe5eef183d190d37cc04db" kind="define" prot="public" static="no">
        <name>CY_ASSERT</name>
        <param><defname>x</defname></param>
        <initializer>do {                \
                                if(!(x))        \
                                {               \
                                    <ref kindref="member" refid="group__group__utils_1ga80391b71fc1f6ec0a82d00866a168f38">CY_HALT</ref>();  \
                                }               \
                            } while(false)</initializer>
        <briefdescription>
<para>Utility macro when neither NDEBUG or CY_NO_ASSERT is not declared to check a condition and, if false, trigger a breakpoint. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="58" column="14" file="output/libs/core-lib/include/cy_utils.h" line="58" />
      </memberdef>
      <memberdef id="group__group__utils_1gaa7531a66d82ec4ab6c36a26579fedd3f" kind="define" prot="public" static="no">
        <name>CY_LO8</name>
        <param><defname>x</defname></param>
        <initializer>((uint8_t) ((x) &amp; 0xFFU))</initializer>
        <briefdescription>
<para>Get the lower 8 bits of a 16-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="72" column="9" file="output/libs/core-lib/include/cy_utils.h" line="72" />
      </memberdef>
      <memberdef id="group__group__utils_1gaa57842ae9ca46f0e4b6f280e8f4eaa6c" kind="define" prot="public" static="no">
        <name>CY_HI8</name>
        <param><defname>x</defname></param>
        <initializer>((uint8_t) ((uint16_t)(x) &gt;&gt; 8U))</initializer>
        <briefdescription>
<para>Get the upper 8 bits of a 16-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="74" column="9" file="output/libs/core-lib/include/cy_utils.h" line="74" />
      </memberdef>
      <memberdef id="group__group__utils_1ga58340d6e97870eff30ea323d7c529d3b" kind="define" prot="public" static="no">
        <name>CY_LO16</name>
        <param><defname>x</defname></param>
        <initializer>((uint16_t) ((x) &amp; 0xFFFFU))</initializer>
        <briefdescription>
<para>Get the lower 16 bits of a 32-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="77" column="9" file="output/libs/core-lib/include/cy_utils.h" line="77" />
      </memberdef>
      <memberdef id="group__group__utils_1ga4ecbc90074294a4427c78b3385281c80" kind="define" prot="public" static="no">
        <name>CY_HI16</name>
        <param><defname>x</defname></param>
        <initializer>((uint16_t) ((uint32_t)(x) &gt;&gt; 16U))</initializer>
        <briefdescription>
<para>Get the upper 16 bits of a 32-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="79" column="9" file="output/libs/core-lib/include/cy_utils.h" line="79" />
      </memberdef>
      <memberdef id="group__group__utils_1gaaeb74e76832ed842048d448d556f26bb" kind="define" prot="public" static="no">
        <name>CY_SWAP_ENDIAN16</name>
        <param><defname>x</defname></param>
        <initializer>((uint16_t)(((x) &lt;&lt; 8U) | (((x) &gt;&gt; 8U) &amp; 0x00FFU)))</initializer>
        <briefdescription>
<para>Swap the byte ordering of a 16-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="82" column="9" file="output/libs/core-lib/include/cy_utils.h" line="82" />
      </memberdef>
      <memberdef id="group__group__utils_1ga97584523775e03eb4b9443b2c6db1ca9" kind="define" prot="public" static="no">
        <name>CY_SWAP_ENDIAN32</name>
        <param><defname>x</defname></param>
        <initializer>((uint32_t)((((x) &gt;&gt; 24U) &amp; 0x000000FFU) | (((x) &amp; 0x00FF0000U) &gt;&gt; 8U) | \
                                (((x) &amp; 0x0000FF00U) &lt;&lt; 8U) | ((x) &lt;&lt; 24U)))</initializer>
        <briefdescription>
<para>Swap the byte ordering of a 32-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="85" column="9" file="output/libs/core-lib/include/cy_utils.h" line="85" />
      </memberdef>
      <memberdef id="group__group__utils_1gabdb9e784645440db1f74b0060eeec466" kind="define" prot="public" static="no">
        <name>CY_SWAP_ENDIAN64</name>
        <param><defname>x</defname></param>
        <initializer>((uint64_t) (((uint64_t) <ref kindref="member" refid="group__group__utils_1ga97584523775e03eb4b9443b2c6db1ca9">CY_SWAP_ENDIAN32</ref>((uint32_t)(x)) &lt;&lt; 32U) | \
                                CY_SWAP_ENDIAN32((uint32_t)((x) &gt;&gt; 32U))))</initializer>
        <briefdescription>
<para>Swap the byte ordering of a 64-bit value. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="89" column="9" file="output/libs/core-lib/include/cy_utils.h" line="89" />
      </memberdef>
      <memberdef id="group__group__utils_1ga34975c78bf005e734701b46d04811c98" kind="define" prot="public" static="no">
        <name>CY_GET_REG8</name>
        <param><defname>addr</defname></param>
        <initializer>(*((const volatile uint8_t *)(addr)))</initializer>
        <briefdescription>
<para>Reads the 8-bit value from the specified address. </para>        </briefdescription>
        <detaileddescription>
<para>This function can't be used to access the Core register, otherwise a fault occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The read value. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="159" column="9" file="output/libs/core-lib/include/cy_utils.h" line="159" />
      </memberdef>
      <memberdef id="group__group__utils_1gaeca2bcb3d8be3de33fe86b610bf86b90" kind="define" prot="public" static="no">
        <name>CY_SET_REG8</name>
        <param><defname>addr</defname></param>
        <param><defname>value</defname></param>
        <initializer>(*((volatile uint8_t *)(addr)) = (uint8_t)(value))</initializer>
        <briefdescription>
<para>Writes an 8-bit value to the specified address. </para>        </briefdescription>
        <detaileddescription>
<para>This function can't be used to access the Core register, otherwise a fault occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>value</parametername>
</parameternamelist>
<parameterdescription>
<para>The value to write. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="174" column="9" file="output/libs/core-lib/include/cy_utils.h" line="174" />
      </memberdef>
      <memberdef id="group__group__utils_1ga21359444986c07db7fdb6993f313b472" kind="define" prot="public" static="no">
        <name>CY_GET_REG16</name>
        <param><defname>addr</defname></param>
        <initializer>(*((const volatile uint16_t *)(addr)))</initializer>
        <briefdescription>
<para>Reads the 16-bit value from the specified address. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The read value. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="188" column="9" file="output/libs/core-lib/include/cy_utils.h" line="188" />
      </memberdef>
      <memberdef id="group__group__utils_1gaf6fdd73b6a193e60b1b8d11d6cbfcb13" kind="define" prot="public" static="no">
        <name>CY_SET_REG16</name>
        <param><defname>addr</defname></param>
        <param><defname>value</defname></param>
        <initializer>(*((volatile uint16_t *)(addr)) = (uint16_t)(value))</initializer>
        <briefdescription>
<para>Writes the 16-bit value to the specified address. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>value</parametername>
</parameternamelist>
<parameterdescription>
<para>The value to write. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="202" column="9" file="output/libs/core-lib/include/cy_utils.h" line="202" />
      </memberdef>
      <memberdef id="group__group__utils_1ga08558965aa9ed40b40be2e03382e866d" kind="define" prot="public" static="no">
        <name>CY_GET_REG24</name>
        <param><defname>addr</defname></param>
        <initializer>(((uint32_t) (*((const volatile uint8_t *)(addr)))) | \
                                    (((uint32_t) (*((const volatile uint8_t *)(addr) + 1))) &lt;&lt; 8U) | \
                                    (((uint32_t) (*((const volatile uint8_t *)(addr) + 2))) &lt;&lt; 16U))</initializer>
        <briefdescription>
<para>Reads the 24-bit value from the specified address. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The read value. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="216" column="9" file="output/libs/core-lib/include/cy_utils.h" line="216" />
      </memberdef>
      <memberdef id="group__group__utils_1ga749ab39829e9caf8955d91dd355fe8b3" kind="define" prot="public" static="no">
        <name>CY_SET_REG24</name>
        <param><defname>addr</defname></param>
        <param><defname>value</defname></param>
        <initializer>do  \
                                    {   \
                                        (*((volatile uint8_t *) (addr))) = (uint8_t)(value);                \
                                        (*((volatile uint8_t *) (addr) + 1)) = (uint8_t)((value) &gt;&gt; 8U);    \
                                        (*((volatile uint8_t *) (addr) + 2)) = (uint8_t)((value) &gt;&gt; 16U);   \
                                    }   \
                                    while(0)</initializer>
        <briefdescription>
<para>Writes the 24-bit value to the specified address. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>value</parametername>
</parameternamelist>
<parameterdescription>
<para>The value to write. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="232" column="9" file="output/libs/core-lib/include/cy_utils.h" line="232" />
      </memberdef>
      <memberdef id="group__group__utils_1ga99c7cedf249c18295512d896086dc64f" kind="define" prot="public" static="no">
        <name>CY_GET_REG32</name>
        <param><defname>addr</defname></param>
        <initializer>(*((const volatile uint32_t *)(addr)))</initializer>
        <briefdescription>
<para>Reads the 32-bit value from the specified register. </para>        </briefdescription>
        <detaileddescription>
<para>The address is the little endian order (LSB in lowest address).</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The read value. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="253" column="9" file="output/libs/core-lib/include/cy_utils.h" line="253" />
      </memberdef>
      <memberdef id="group__group__utils_1gafc826bc60da53abdb37e1e12c91d148a" kind="define" prot="public" static="no">
        <name>CY_SET_REG32</name>
        <param><defname>addr</defname></param>
        <param><defname>value</defname></param>
        <initializer>(*((volatile uint32_t *)(addr)) = (uint32_t)(value))</initializer>
        <briefdescription>
<para>Writes the 32-bit value to the specified register. </para>        </briefdescription>
        <detaileddescription>
<para>The address is the little endian order (LSB in lowest address).</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>addr</parametername>
</parameternamelist>
<parameterdescription>
<para>The register address.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>value</parametername>
</parameternamelist>
<parameterdescription>
<para>The value to write. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="268" column="9" file="output/libs/core-lib/include/cy_utils.h" line="268" />
      </memberdef>
      <memberdef id="group__group__utils_1ga7dfff5dad289133d84f2c1caddd0382e" kind="define" prot="public" static="no">
        <name>_CLR_SET_FLD32U</name>
        <param><defname>reg</defname></param>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>(((reg) &amp; ((uint32_t)(~(field ## _Msk)))) | (_VAL2FLD(field, value)))</initializer>
        <briefdescription>
<para>The macro for setting a register with a name field and value for providing get-clear-modify-write operations. </para>        </briefdescription>
        <detaileddescription>
<para>Returns a resulting value to be assigned to the register. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="280" column="9" file="output/libs/core-lib/include/cy_utils.h" line="280" />
      </memberdef>
      <memberdef id="group__group__utils_1ga6873efbed50e1e0485e5f3279f193aa2" kind="define" prot="public" static="no">
        <name>CY_REG32_CLR_SET</name>
        <param><defname>reg</defname></param>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>((reg) = <ref kindref="member" refid="group__group__utils_1ga7dfff5dad289133d84f2c1caddd0382e">_CLR_SET_FLD32U</ref>((reg), field, (value)))</initializer>
        <briefdescription>
<para>Uses _CLR_SET_FLD32U macro for providing get-clear-modify-write operations with a name field and value and writes a resulting value to the 32-bit register. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="292" column="9" file="output/libs/core-lib/include/cy_utils.h" line="292" />
      </memberdef>
      <memberdef id="group__group__utils_1ga10a2bdfbcf75aed8d292209057b0ee6b" kind="define" prot="public" static="no">
        <name>_CLR_SET_FLD16U</name>
        <param><defname>reg</defname></param>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>((uint16_t)(((reg) &amp; ((uint16_t)(~(field ## _Msk)))) |   \
                                                       ((uint16_t)_VAL2FLD(field, value))))</initializer>
        <briefdescription>
<para>The macro for setting a 16-bit register with a name field and value for providing get-clear-modify-write operations. </para>        </briefdescription>
        <detaileddescription>
<para>Returns a resulting value to be assigned to the 16-bit register. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="304" column="9" file="output/libs/core-lib/include/cy_utils.h" line="304" />
      </memberdef>
      <memberdef id="group__group__utils_1gab2b4fa8f484a8308eadec61e80e82623" kind="define" prot="public" static="no">
        <name>CY_REG16_CLR_SET</name>
        <param><defname>reg</defname></param>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>((reg) = <ref kindref="member" refid="group__group__utils_1ga10a2bdfbcf75aed8d292209057b0ee6b">_CLR_SET_FLD16U</ref>((reg), field, (value)))</initializer>
        <briefdescription>
<para>Uses _CLR_SET_FLD16U macro for providing get-clear-modify-write operations with a name field and value and writes a resulting value to the 16-bit register. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="317" column="9" file="output/libs/core-lib/include/cy_utils.h" line="317" />
      </memberdef>
      <memberdef id="group__group__utils_1ga5e3bafb985f38613bde1147dc73fcf65" kind="define" prot="public" static="no">
        <name>_CLR_SET_FLD8U</name>
        <param><defname>reg</defname></param>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>((uint8_t)(((reg) &amp; ((uint8_t)(~(field ## _Msk)))) |  \
                                                     ((uint8_t)_VAL2FLD(field, value))))</initializer>
        <briefdescription>
<para>The macro for setting a 8-bit register with a name field and value for providing get-clear-modify-write operations. </para>        </briefdescription>
        <detaileddescription>
<para>Returns a resulting value to be assigned to the 8-bit register. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="329" column="9" file="output/libs/core-lib/include/cy_utils.h" line="329" />
      </memberdef>
      <memberdef id="group__group__utils_1gac927ea147352133e7a1ead8913247d90" kind="define" prot="public" static="no">
        <name>CY_REG8_CLR_SET</name>
        <param><defname>reg</defname></param>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>((reg) = <ref kindref="member" refid="group__group__utils_1ga5e3bafb985f38613bde1147dc73fcf65">_CLR_SET_FLD8U</ref>((reg), field, (value)))</initializer>
        <briefdescription>
<para>Uses _CLR_SET_FLD8U macro for providing get-clear-modify-write operations with a name field and value and writes a resulting value to the 8-bit register. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="342" column="9" file="output/libs/core-lib/include/cy_utils.h" line="342" />
      </memberdef>
      <memberdef id="group__group__utils_1ga935b8fbcfd877d03f234825f296e7ac9" kind="define" prot="public" static="no">
        <name>_BOOL2FLD</name>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>(((value) != false) ? (field ## _Msk) : 0UL)</initializer>
        <briefdescription>
<para>Returns a field mask if the value is not false. </para>        </briefdescription>
        <detaileddescription>
<para>Returns 0, if the value is false. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="353" column="9" file="output/libs/core-lib/include/cy_utils.h" line="353" />
      </memberdef>
      <memberdef id="group__group__utils_1ga8d9ee76c64031ffe440b12e55bf6947d" kind="define" prot="public" static="no">
        <name>_FLD2BOOL</name>
        <param><defname>field</defname></param>
        <param><defname>value</defname></param>
        <initializer>(((value) &amp; (field ## _Msk)) != 0UL)</initializer>
        <briefdescription>
<para>Returns true, if the value includes the field mask. </para>        </briefdescription>
        <detaileddescription>
<para>Returns false, if the value doesn't include the field mask. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="364" column="9" file="output/libs/core-lib/include/cy_utils.h" line="364" />
      </memberdef>
      <memberdef id="group__group__utils_1ga05f244da002bc0c7dc9c1475053f8cfd" kind="define" prot="public" static="no">
        <name>CY_SYSLIB_DIV_ROUND</name>
        <param><defname>a</defname></param>
        <param><defname>b</defname></param>
        <initializer>(((a) + ((b) / 2U)) / (b))</initializer>
        <briefdescription>
<para>Calculates a / b with rounding to the nearest integer, a and b must have the same sign. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="375" column="9" file="output/libs/core-lib/include/cy_utils.h" line="375" />
      </memberdef>
      <memberdef id="group__group__utils_1ga7b4264645556dd22feb8b877a283e2a2" kind="define" prot="public" static="no">
        <name>CY_SYSLIB_DIV_ROUNDUP</name>
        <param><defname>a</defname></param>
        <param><defname>b</defname></param>
        <initializer>((((a) - 1U) / (b)) + 1U)</initializer>
        <briefdescription>
<para>Calculates a / b with rounding up if remainder != 0, both a and b must be positive. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="386" column="9" file="output/libs/core-lib/include/cy_utils.h" line="386" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__utils_1ga80391b71fc1f6ec0a82d00866a168f38" inline="yes" kind="function" prot="public" static="yes" virt="non-virtual">
        <type>void</type>
        <definition>static void CY_HALT</definition>
        <argsstring>(void)</argsstring>
        <name>CY_HALT</name>
        <param>
          <type>void</type>
        </param>
        <briefdescription>
<para>Halt the processor in the debug state. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="47" bodyfile="output/libs/core-lib/include/cy_utils.h" bodystart="44" column="1" file="output/libs/core-lib/include/cy_utils.h" line="44" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Basic utility macros and functions. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="32"><highlight class="preprocessor">#if<sp />!defined(CY_UTILS_H)</highlight><highlight class="normal" /></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_UTILS_H</highlight><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /></codeline>
<codeline lineno="40"><highlight class="preprocessor">#define<sp />CY_UNUSED_PARAMETER(x)<sp />(<sp />(void)(x)<sp />)</highlight><highlight class="normal" /></codeline>
<codeline lineno="41"><highlight class="normal" /></codeline>
<codeline lineno="44"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">inline</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__utils_1ga80391b71fc1f6ec0a82d00866a168f38">CY_HALT</ref>(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="45"><highlight class="normal">{</highlight></codeline>
<codeline lineno="46"><highlight class="normal"><sp /><sp /><sp /><sp />__asm(</highlight><highlight class="stringliteral">"<sp /><sp /><sp /><sp />bkpt<sp /><sp /><sp /><sp />1"</highlight><highlight class="normal">);</highlight></codeline>
<codeline lineno="47"><highlight class="normal">}</highlight></codeline>
<codeline lineno="48"><highlight class="normal" /></codeline>
<codeline lineno="49"><highlight class="normal" /><highlight class="preprocessor">#ifdef<sp />CY_ASSERT</highlight><highlight class="normal" /></codeline>
<codeline lineno="50"><highlight class="normal" /><highlight class="preprocessor">#undef<sp />CY_ASSERT</highlight><highlight class="normal" /></codeline>
<codeline lineno="51"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />ifdef(CY_ASSERT)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal" /></codeline>
<codeline lineno="54"><highlight class="preprocessor">#if<sp />defined(NDEBUG)<sp />||<sp />defined(CY_NO_ASSERT)</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_ASSERT(x)<sp /><sp /><sp /><sp />do<sp />{<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="56"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp />while(false)</highlight><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_ASSERT(x)<sp /><sp /><sp /><sp />do<sp />{<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="59"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />if(!(x))<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="60"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="61"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_HALT();<sp /><sp />\</highlight></codeline>
<codeline lineno="62"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="63"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp />while(false)</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /><sp /></highlight><highlight class="comment">/*<sp />defined(NDEBUG)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="68"><highlight class="comment">*<sp /><sp />Data<sp />manipulation<sp />defines</highlight></codeline>
<codeline lineno="69"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="preprocessor">#define<sp />CY_LO8(x)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint8_t)<sp />((x)<sp />&amp;<sp />0xFFU))</highlight><highlight class="normal" /></codeline>
<codeline lineno="73"><highlight class="normal" /></codeline>
<codeline lineno="74"><highlight class="preprocessor">#define<sp />CY_HI8(x)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint8_t)<sp />((uint16_t)(x)<sp />&gt;&gt;<sp />8U))</highlight><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="preprocessor">#define<sp />CY_LO16(x)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint16_t)<sp />((x)<sp />&amp;<sp />0xFFFFU))</highlight><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="preprocessor">#define<sp />CY_HI16(x)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint16_t)<sp />((uint32_t)(x)<sp />&gt;&gt;<sp />16U))</highlight><highlight class="normal" /></codeline>
<codeline lineno="80"><highlight class="normal" /></codeline>
<codeline lineno="82"><highlight class="preprocessor">#define<sp />CY_SWAP_ENDIAN16(x)<sp /><sp /><sp /><sp /><sp />((uint16_t)(((x)<sp />&lt;&lt;<sp />8U)<sp />|<sp />(((x)<sp />&gt;&gt;<sp />8U)<sp />&amp;<sp />0x00FFU)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="preprocessor">#define<sp />CY_SWAP_ENDIAN32(x)<sp /><sp /><sp /><sp /><sp />((uint32_t)((((x)<sp />&gt;&gt;<sp />24U)<sp />&amp;<sp />0x000000FFU)<sp />|<sp />(((x)<sp />&amp;<sp />0x00FF0000U)<sp />&gt;&gt;<sp />8U)<sp />|<sp />\</highlight></codeline>
<codeline lineno="86"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((x)<sp />&amp;<sp />0x0000FF00U)<sp />&lt;&lt;<sp />8U)<sp />|<sp />((x)<sp />&lt;&lt;<sp />24U)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="preprocessor">#define<sp />CY_SWAP_ENDIAN64(x)<sp /><sp /><sp /><sp /><sp />((uint64_t)<sp />(((uint64_t)<sp />CY_SWAP_ENDIAN32((uint32_t)(x))<sp />&lt;&lt;<sp />32U)<sp />|<sp />\</highlight></codeline>
<codeline lineno="90"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_SWAP_ENDIAN32((uint32_t)((x)<sp />&gt;&gt;<sp />32U))))</highlight><highlight class="normal" /></codeline>
<codeline lineno="91"><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal" /></codeline>
<codeline lineno="93"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="94"><highlight class="comment">*<sp /><sp /><sp />Memory<sp />model<sp />definitions</highlight></codeline>
<codeline lineno="95"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="96"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__ARMCC_VERSION)</highlight><highlight class="normal" /></codeline>
<codeline lineno="97"><highlight class="normal" /></codeline>
<codeline lineno="101"><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(__ARMCC_VERSION<sp />&gt;=<sp />6010050)</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_NOINIT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((section(".noinit")))</highlight><highlight class="normal" /></codeline>
<codeline lineno="103"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="104"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_NOINIT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((section(".noinit"),<sp />zero_init))</highlight><highlight class="normal" /></codeline>
<codeline lineno="105"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />(__ARMCC_VERSION<sp />&gt;=<sp />6010050)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="106"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_SECTION(name)<sp /><sp /><sp /><sp />__attribute__<sp />((section(name)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_UNUSED<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((unused))</highlight><highlight class="normal" /></codeline>
<codeline lineno="108"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_NOINLINE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((noinline))</highlight><highlight class="normal" /></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Specifies<sp />the<sp />minimum<sp />alignment<sp />(in<sp />bytes)<sp />for<sp />variables<sp />of<sp />the<sp />specified<sp />type.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="110"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_ALIGN(align)<sp /><sp /><sp /><sp /><sp />__ALIGNED(align)</highlight><highlight class="normal" /></codeline>
<codeline lineno="111"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_BEGIN<sp /><sp /><sp /><sp />__attribute__<sp />((section(".cy_ramfunc")))</highlight><highlight class="normal" /></codeline>
<codeline lineno="112"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_END</highlight><highlight class="normal" /></codeline>
<codeline lineno="113"><highlight class="normal" /><highlight class="preprocessor">#elif<sp />defined<sp />(__GNUC__)</highlight><highlight class="normal" /></codeline>
<codeline lineno="114"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />defined<sp />(__clang__)</highlight><highlight class="normal" /></codeline>
<codeline lineno="115"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_NOINIT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((section("__DATA,<sp />__noinit")))</highlight><highlight class="normal" /></codeline>
<codeline lineno="116"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_SECTION(name)<sp /><sp /><sp /><sp />__attribute__<sp />((section("__DATA,<sp />"name)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="117"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_BEGIN<sp /><sp /><sp /><sp />__attribute__<sp />((section("__DATA,<sp />.cy_ramfunc")))</highlight><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_END</highlight><highlight class="normal" /></codeline>
<codeline lineno="119"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="120"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_NOINIT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((section(".noinit")))</highlight><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_SECTION(name)<sp /><sp /><sp /><sp />__attribute__<sp />((section(name)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="122"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_BEGIN<sp /><sp /><sp /><sp />__attribute__<sp />((section(".cy_ramfunc")))</highlight><highlight class="normal" /></codeline>
<codeline lineno="123"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_END</highlight><highlight class="normal" /></codeline>
<codeline lineno="124"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="normal" /></codeline>
<codeline lineno="126"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_UNUSED<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((unused))</highlight><highlight class="normal" /></codeline>
<codeline lineno="127"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_NOINLINE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__attribute__<sp />((noinline))</highlight><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_ALIGN(align)<sp /><sp /><sp /><sp /><sp />__ALIGNED(align)</highlight><highlight class="normal" /></codeline>
<codeline lineno="129"><highlight class="normal" /><highlight class="preprocessor">#elif<sp />defined<sp />(__ICCARM__)</highlight><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_PRAGMA(x)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_Pragma(#x)</highlight><highlight class="normal" /></codeline>
<codeline lineno="131"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_NOINIT<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />__no_init</highlight><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_SECTION(name)<sp /><sp /><sp /><sp />CY_PRAGMA(location<sp />=<sp />name)</highlight><highlight class="normal" /></codeline>
<codeline lineno="133"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_UNUSED</highlight><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_NOINLINE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_PRAGMA(optimize<sp />=<sp />no_inline)</highlight><highlight class="normal" /></codeline>
<codeline lineno="135"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_BEGIN<sp /><sp /><sp /><sp />CY_PRAGMA(diag_suppress<sp />=<sp />Ta023)<sp />__ramfunc</highlight><highlight class="normal" /></codeline>
<codeline lineno="136"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CY_RAMFUNC_END<sp /><sp /><sp /><sp /><sp /><sp />CY_PRAGMA(diag_default<sp />=<sp />Ta023)</highlight><highlight class="normal" /></codeline>
<codeline lineno="137"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(__VER__<sp />&lt;<sp />8010001)</highlight><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_ALIGN(align)<sp />CY_PRAGMA(data_alignment<sp />=<sp />align)</highlight><highlight class="normal" /></codeline>
<codeline lineno="139"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="140"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#define<sp />CY_ALIGN(align)<sp />__ALIGNED(align)</highlight><highlight class="normal" /></codeline>
<codeline lineno="141"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif<sp /></highlight><highlight class="comment">/*<sp />(__VER__<sp />&lt;<sp />8010001)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="142"><highlight class="normal" /><highlight class="preprocessor">#else</highlight><highlight class="normal" /></codeline>
<codeline lineno="143"><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#error<sp />"An<sp />unsupported<sp />toolchain"</highlight><highlight class="normal" /></codeline>
<codeline lineno="144"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /><sp /></highlight><highlight class="comment">/*<sp />(__ARMCC_VERSION)<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="145"><highlight class="normal" /></codeline>
<codeline lineno="146"><highlight class="normal" /></codeline>
<codeline lineno="147"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="148"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_GET_REG8(addr)</highlight></codeline>
<codeline lineno="149"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="159"><highlight class="preprocessor">#define<sp />CY_GET_REG8(addr)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*((const<sp />volatile<sp />uint8_t<sp />*)(addr)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="160"><highlight class="normal" /></codeline>
<codeline lineno="161"><highlight class="normal" /></codeline>
<codeline lineno="162"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="163"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_SET_REG8(addr,<sp />value)</highlight></codeline>
<codeline lineno="164"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="174"><highlight class="preprocessor">#define<sp />CY_SET_REG8(addr,<sp />value)<sp /><sp /><sp /><sp />(*((volatile<sp />uint8_t<sp />*)(addr))<sp />=<sp />(uint8_t)(value))</highlight><highlight class="normal" /></codeline>
<codeline lineno="175"><highlight class="normal" /></codeline>
<codeline lineno="176"><highlight class="normal" /></codeline>
<codeline lineno="177"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="178"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_GET_REG16(addr)</highlight></codeline>
<codeline lineno="179"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="188"><highlight class="preprocessor">#define<sp />CY_GET_REG16(addr)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*((const<sp />volatile<sp />uint16_t<sp />*)(addr)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="189"><highlight class="normal" /></codeline>
<codeline lineno="190"><highlight class="normal" /></codeline>
<codeline lineno="191"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="192"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_SET_REG16(addr,<sp />value)</highlight></codeline>
<codeline lineno="193"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="202"><highlight class="preprocessor">#define<sp />CY_SET_REG16(addr,<sp />value)<sp /><sp /><sp />(*((volatile<sp />uint16_t<sp />*)(addr))<sp />=<sp />(uint16_t)(value))</highlight><highlight class="normal" /></codeline>
<codeline lineno="203"><highlight class="normal" /></codeline>
<codeline lineno="204"><highlight class="normal" /></codeline>
<codeline lineno="205"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="206"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_GET_REG24(addr)</highlight></codeline>
<codeline lineno="207"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="216"><highlight class="preprocessor">#define<sp />CY_GET_REG24(addr)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((uint32_t)<sp />(*((const<sp />volatile<sp />uint8_t<sp />*)(addr))))<sp />|<sp />\</highlight></codeline>
<codeline lineno="217"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((uint32_t)<sp />(*((const<sp />volatile<sp />uint8_t<sp />*)(addr)<sp />+<sp />1)))<sp />&lt;&lt;<sp />8U)<sp />|<sp />\</highlight></codeline>
<codeline lineno="218"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((uint32_t)<sp />(*((const<sp />volatile<sp />uint8_t<sp />*)(addr)<sp />+<sp />2)))<sp />&lt;&lt;<sp />16U))</highlight><highlight class="normal" /></codeline>
<codeline lineno="219"><highlight class="normal" /></codeline>
<codeline lineno="220"><highlight class="normal" /></codeline>
<codeline lineno="221"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="222"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_SET_REG24(addr,<sp />value)</highlight></codeline>
<codeline lineno="223"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="232"><highlight class="preprocessor">#define<sp />CY_SET_REG24(addr,<sp />value)<sp /><sp /><sp />do<sp /><sp />\</highlight></codeline>
<codeline lineno="233"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{<sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="234"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*((volatile<sp />uint8_t<sp />*)<sp />(addr)))<sp />=<sp />(uint8_t)(value);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="235"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*((volatile<sp />uint8_t<sp />*)<sp />(addr)<sp />+<sp />1))<sp />=<sp />(uint8_t)((value)<sp />&gt;&gt;<sp />8U);<sp /><sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="236"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*((volatile<sp />uint8_t<sp />*)<sp />(addr)<sp />+<sp />2))<sp />=<sp />(uint8_t)((value)<sp />&gt;&gt;<sp />16U);<sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="237"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}<sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="238"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />while(0)</highlight><highlight class="normal" /></codeline>
<codeline lineno="239"><highlight class="normal" /></codeline>
<codeline lineno="240"><highlight class="normal" /></codeline>
<codeline lineno="241"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="242"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_GET_REG32(addr)</highlight></codeline>
<codeline lineno="243"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="253"><highlight class="preprocessor">#define<sp />CY_GET_REG32(addr)<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*((const<sp />volatile<sp />uint32_t<sp />*)(addr)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="254"><highlight class="normal" /></codeline>
<codeline lineno="255"><highlight class="normal" /></codeline>
<codeline lineno="256"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="257"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_SET_REG32(addr,<sp />value)</highlight></codeline>
<codeline lineno="258"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="268"><highlight class="preprocessor">#define<sp />CY_SET_REG32(addr,<sp />value)<sp /><sp /><sp />(*((volatile<sp />uint32_t<sp />*)(addr))<sp />=<sp />(uint32_t)(value))</highlight><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal" /></codeline>
<codeline lineno="270"><highlight class="normal" /></codeline>
<codeline lineno="271"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="272"><highlight class="comment">*<sp />Macro<sp />Name:<sp />_CLR_SET_FLD32U</highlight></codeline>
<codeline lineno="273"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="280"><highlight class="preprocessor">#define<sp />_CLR_SET_FLD32U(reg,<sp />field,<sp />value)<sp />(((reg)<sp />&amp;<sp />((uint32_t)(~(field<sp />##<sp />_Msk))))<sp />|<sp />(_VAL2FLD(field,<sp />value)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="281"><highlight class="normal" /></codeline>
<codeline lineno="282"><highlight class="normal" /></codeline>
<codeline lineno="283"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="284"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_REG32_CLR_SET</highlight></codeline>
<codeline lineno="285"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="292"><highlight class="preprocessor">#define<sp />CY_REG32_CLR_SET(reg,<sp />field,<sp />value)<sp />((reg)<sp />=<sp />_CLR_SET_FLD32U((reg),<sp />field,<sp />(value)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="293"><highlight class="normal" /></codeline>
<codeline lineno="294"><highlight class="normal" /></codeline>
<codeline lineno="295"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="296"><highlight class="comment">*<sp />Macro<sp />Name:<sp />_CLR_SET_FLD16U</highlight></codeline>
<codeline lineno="297"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="304"><highlight class="preprocessor">#define<sp />_CLR_SET_FLD16U(reg,<sp />field,<sp />value)<sp />((uint16_t)(((reg)<sp />&amp;<sp />((uint16_t)(~(field<sp />##<sp />_Msk))))<sp />|<sp /><sp /><sp />\</highlight></codeline>
<codeline lineno="305"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint16_t)_VAL2FLD(field,<sp />value))))</highlight><highlight class="normal" /></codeline>
<codeline lineno="306"><highlight class="normal" /></codeline>
<codeline lineno="307"><highlight class="normal" /></codeline>
<codeline lineno="308"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="309"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_REG16_CLR_SET</highlight></codeline>
<codeline lineno="310"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="317"><highlight class="preprocessor">#define<sp />CY_REG16_CLR_SET(reg,<sp />field,<sp />value)<sp />((reg)<sp />=<sp />_CLR_SET_FLD16U((reg),<sp />field,<sp />(value)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="318"><highlight class="normal" /></codeline>
<codeline lineno="319"><highlight class="normal" /></codeline>
<codeline lineno="320"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="321"><highlight class="comment">*<sp />Macro<sp />Name:<sp />_CLR_SET_FLD8U</highlight></codeline>
<codeline lineno="322"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="329"><highlight class="preprocessor">#define<sp />_CLR_SET_FLD8U(reg,<sp />field,<sp />value)<sp />((uint8_t)(((reg)<sp />&amp;<sp />((uint8_t)(~(field<sp />##<sp />_Msk))))<sp />|<sp /><sp />\</highlight></codeline>
<codeline lineno="330"><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((uint8_t)_VAL2FLD(field,<sp />value))))</highlight><highlight class="normal" /></codeline>
<codeline lineno="331"><highlight class="normal" /></codeline>
<codeline lineno="332"><highlight class="normal" /></codeline>
<codeline lineno="333"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="334"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_REG8_CLR_SET</highlight></codeline>
<codeline lineno="335"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="342"><highlight class="preprocessor">#define<sp />CY_REG8_CLR_SET(reg,<sp />field,<sp />value)<sp />((reg)<sp />=<sp />_CLR_SET_FLD8U((reg),<sp />field,<sp />(value)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="343"><highlight class="normal" /></codeline>
<codeline lineno="344"><highlight class="normal" /></codeline>
<codeline lineno="345"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="346"><highlight class="comment">*<sp />Macro<sp />Name:<sp />_BOOL2FLD</highlight></codeline>
<codeline lineno="347"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="353"><highlight class="preprocessor">#define<sp />_BOOL2FLD(field,<sp />value)<sp />(((value)<sp />!=<sp />false)<sp />?<sp />(field<sp />##<sp />_Msk)<sp />:<sp />0UL)</highlight><highlight class="normal" /></codeline>
<codeline lineno="354"><highlight class="normal" /></codeline>
<codeline lineno="355"><highlight class="normal" /></codeline>
<codeline lineno="356"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="357"><highlight class="comment">*<sp />Macro<sp />Name:<sp />_FLD2BOOL</highlight></codeline>
<codeline lineno="358"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="364"><highlight class="preprocessor">#define<sp />_FLD2BOOL(field,<sp />value)<sp />(((value)<sp />&amp;<sp />(field<sp />##<sp />_Msk))<sp />!=<sp />0UL)</highlight><highlight class="normal" /></codeline>
<codeline lineno="365"><highlight class="normal" /></codeline>
<codeline lineno="366"><highlight class="normal" /></codeline>
<codeline lineno="367"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="368"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_SYSLIB_DIV_ROUND</highlight></codeline>
<codeline lineno="369"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="375"><highlight class="preprocessor">#define<sp />CY_SYSLIB_DIV_ROUND(a,<sp />b)<sp />(((a)<sp />+<sp />((b)<sp />/<sp />2U))<sp />/<sp />(b))</highlight><highlight class="normal" /></codeline>
<codeline lineno="376"><highlight class="normal" /></codeline>
<codeline lineno="377"><highlight class="normal" /></codeline>
<codeline lineno="378"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="379"><highlight class="comment">*<sp />Macro<sp />Name:<sp />CY_SYSLIB_DIV_ROUNDUP</highlight></codeline>
<codeline lineno="380"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="386"><highlight class="preprocessor">#define<sp />CY_SYSLIB_DIV_ROUNDUP(a,<sp />b)<sp />((((a)<sp />-<sp />1U)<sp />/<sp />(b))<sp />+<sp />1U)</highlight><highlight class="normal" /></codeline>
<codeline lineno="387"><highlight class="normal" /></codeline>
<codeline lineno="388"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="389"><highlight class="comment">*<sp /><sp />Provides<sp />the<sp />macros<sp />for<sp />MISRA<sp />violation<sp />documentation<sp />in<sp />Coverity<sp />tool.</highlight></codeline>
<codeline lineno="390"><highlight class="comment">*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="391"><highlight class="normal" /></codeline>
<codeline lineno="394"><highlight class="preprocessor">#ifdef<sp />CY_COVERITY_2012_CHECK<sp /></highlight><highlight class="comment">/*<sp />Check<sp />MISRA-C:2012<sp />with<sp />Coverity<sp />tool<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="395"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_COVERITY_PRAGMA_STR(a)<sp />#a</highlight><highlight class="normal" /></codeline>
<codeline lineno="396"><highlight class="normal" /></codeline>
<codeline lineno="397"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_DEVIATE_LINE(MISRA,MESSAGE)<sp />\</highlight></codeline>
<codeline lineno="398"><highlight class="preprocessor">_Pragma(CY_COVERITY_PRAGMA_STR(coverity<sp />compliance<sp />deviate<sp />MISRA<sp />MESSAGE))</highlight><highlight class="normal" /></codeline>
<codeline lineno="399"><highlight class="normal" /></codeline>
<codeline lineno="400"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_FP_LINE(MISRA,MESSAGE)<sp />\</highlight></codeline>
<codeline lineno="401"><highlight class="preprocessor">_Pragma(CY_COVERITY_PRAGMA_STR(coverity<sp />compliance<sp />fp<sp />MISRA<sp />MESSAGE))</highlight><highlight class="normal" /></codeline>
<codeline lineno="402"><highlight class="normal" /></codeline>
<codeline lineno="403"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_DEVIATE_BLOCK_START(MISRA,COUNT,MESSAGE)<sp />\</highlight></codeline>
<codeline lineno="404"><highlight class="preprocessor">_Pragma(CY_COVERITY_PRAGMA_STR(coverity<sp />compliance<sp />block<sp />(deviate:COUNT<sp />MISRA<sp />MESSAGE)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="405"><highlight class="normal" /></codeline>
<codeline lineno="406"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_FP_BLOCK_START(MISRA,COUNT,MESSAGE)<sp />\</highlight></codeline>
<codeline lineno="407"><highlight class="preprocessor">_Pragma(CY_COVERITY_PRAGMA_STR(coverity<sp />compliance<sp />block<sp />(fp:COUNT<sp />MISRA<sp />MESSAGE)))</highlight><highlight class="normal" /></codeline>
<codeline lineno="408"><highlight class="normal" /></codeline>
<codeline lineno="409"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_BLOCK_END(MISRA)<sp />\</highlight></codeline>
<codeline lineno="410"><highlight class="preprocessor">_Pragma(CY_COVERITY_PRAGMA_STR(coverity<sp />compliance<sp />end_block<sp />MISRA))</highlight><highlight class="normal" /></codeline>
<codeline lineno="411"><highlight class="normal" /></codeline>
<codeline lineno="412"><highlight class="normal" /><highlight class="preprocessor">#else<sp /></highlight><highlight class="comment">/*<sp />General<sp />usage<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="413"><highlight class="normal" /></codeline>
<codeline lineno="414"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_DEVIATE_LINE(MISRA,MESSAGE)<sp />do{}while(false)</highlight><highlight class="normal" /></codeline>
<codeline lineno="415"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_FP_LINE(MISRA,MESSAGE)<sp />do{}while(false)</highlight><highlight class="normal" /></codeline>
<codeline lineno="416"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_DEVIATE_BLOCK_START(MISRA,COUNT,MESSAGE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="417"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_FP_BLOCK_START(MISRA,COUNT,MESSAGE)</highlight><highlight class="normal" /></codeline>
<codeline lineno="418"><highlight class="normal" /><highlight class="preprocessor">#define<sp />CY_MISRA_BLOCK_END(MISRA)</highlight><highlight class="normal" /></codeline>
<codeline lineno="419"><highlight class="normal" /></codeline>
<codeline lineno="420"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_COVERITY_2012_CHECK<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="421"><highlight class="normal" /></codeline>
<codeline lineno="424"><highlight class="preprocessor">#ifdef<sp />__cplusplus</highlight><highlight class="normal" /></codeline>
<codeline lineno="425"><highlight class="normal">}</highlight></codeline>
<codeline lineno="426"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="427"><highlight class="normal" /></codeline>
<codeline lineno="428"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_UTILS_H<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="429"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/core-lib/include/cy_utils.h" />
  </compounddef>
</doxygen>